de.dhbwstuttgart.typeinference

## Class ResultSet

- java.lang.Object
- - de.dhbwstuttgart.typeinference.ResultSet

- All Implemented Interfaces:
    java.lang.Iterable<Pair>

      public class ResultSet
      extends java.lang.Object
      implements java.lang.Iterable<Pair>

  Im Grunde Sammlung von Pair s mit Equal-Operatoren.
  Author:
    Andreas Stadelmeier, a10023

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) Menge<Pair>` | `resultPairs`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ResultSet()` Erstellt ein leeres ResultSet
    `ResultSet(Menge<Pair> resultSet)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `contains(Type tA1)` Durchsucht das ResultSet (die unifizierten Constraints des ResultSets) nach diesem Typ.
    `boolean` | `equals(java.lang.Object obj)`
    `private int` | `findPairWithTypeEqualTo(Type type, Menge<Pair> inResultPairs)`
    `Menge<Pair>` | `getConstraintsFor(Menge<TypePlaceholder> typePlaceholders)` Sammelt alle Constraints, welche mit den Ã¼bergebenen TPH's in Verbindung stehen.
    `Menge<Pair>` | `getResultSet()`
    `Type` | `getTypeEqualTo(Type type)` LÃ¶st den Ã¼bergebenen Typ auf.
    `Menge<Type>` | `getTypesInvolving(Menge<TypePlaceholder> unresolvedTPH)` Durchsucht das ResultSet nach Typen, die die Ã¼bergebenen unresolvedTPHs als generische Variablen einbinden.
    `java.util.Iterator<Pair>` | `iterator()`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

- - ### Field Detail

    - #### resultPairs

          Menge<Pair> resultPairs

  - ### Constructor Detail

    - #### ResultSet

          public ResultSet(Menge<Pair> resultSet)

    - #### ResultSet

          public ResultSet()

      Erstellt ein leeres ResultSet

  - ### Method Detail

    - #### getResultSet

          public Menge<Pair> getResultSet()

    - #### getTypeEqualTo

          public Type getTypeEqualTo(Type type)

      LÃ¶st den Ã¼bergebenen Typ auf. RÃ¼ckgabetyp ist ein Reftype oder Void
      Parameters:
        `type` -
      Returns:

    - #### findPairWithTypeEqualTo

          private int findPairWithTypeEqualTo(Type type,
                                              Menge<Pair> inResultPairs)

    - #### iterator

          public java.util.Iterator<Pair> iterator()

      Specified by:
        `iterator` in interface `java.lang.Iterable<Pair>`

    - #### contains

          public boolean contains(Type tA1)

      Durchsucht das ResultSet (die unifizierten Constraints des ResultSets) nach diesem Typ. Der Typ wird nicht aufgelÃ¶st. Es spielt keine Rolle in welchem Kontext der Typ im ResultSet auftaucht.
      Parameters:
        `tA1` -
      Returns:
        true, falls der gesuchte Typ enthalten ist.

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### getConstraintsFor

          public Menge<Pair> getConstraintsFor(Menge<TypePlaceholder> typePlaceholders)

      Sammelt alle Constraints, welche mit den Ã¼bergebenen TPH's in Verbindung stehen. Auch alle Constraints, welche wiederum mit den gesammelten Constraints in Verbindung stehen werden gesammelt.
      Returns:

    - #### getTypesInvolving

          public Menge<Type> getTypesInvolving(Menge<TypePlaceholder> unresolvedTPH)

      Durchsucht das ResultSet nach Typen, die die Ã¼bergebenen unresolvedTPHs als generische Variablen einbinden.
      Parameters:
        `unresolvedTPH` -
      Returns: